
plugins {
    kotlin("jvm")
}

val specifyKotlinAsDependency: String by project

repositories {
    mavenCentral()
}

dependencies {
    testImplementation("org.jetbrains.kotlin:kotlin-test")

    implementation(project(":"))
}

publishing {
    publications {
        create<MavenPublication>("mavenJava") {
            from(components["java"])
            artifact(tasks["sourceJar"])

            pom {
                dependencies {
                    if (specifyKotlinAsDependency.toBoolean()) implementation(kotlin("stdlib"))

                    implementation(project(":"))
                }
            }
        }
    }
}
