package ru.dbotthepony.kommons.event

import it.unimi.dsi.fastutil.booleans.BooleanConsumer
import java.util.function.Consumer

interface IBooleanSubscriptable : ISubscriptable<Boolean> {
	@Deprecated("Use type specific listener")
	override fun addListener(listener: Consumer<Boolean>): ISubscriptable.L {
		return addListener(listener::accept)
	}

	fun addListener(listener: BooleanConsumer): ISubscriptable.L

	class Impl : IBooleanSubscriptable, Consumer<Boolean>, BooleanConsumer {
		private inner class L(val callback: BooleanConsumer) : ISubscriptable.L {
			private var isRemoved = false

			init {
				subscribers.add(this)
			}

			override fun remove() {
				if (!isRemoved) {
					isRemoved = true
					queue.add(this)
				}
			}
		}

		private val subscribers = ArrayList<L>(0)
		private val queue = ArrayList<L>(0)

		override fun addListener(listener: BooleanConsumer): ISubscriptable.L {
			return L(listener)
		}

		override fun accept(t: Boolean) {
			queue.forEach { subscribers.remove(it) }
			queue.clear()
			subscribers.forEach { it.callback.accept(t) }
		}
	}
}