package ru.dbotthepony.kommons.event

import java.util.function.Consumer
import java.util.function.DoubleConsumer

interface IDoubleSubcripable : ISubscriptable<Double> {
	@Deprecated("Use type specific listener")
	override fun addListener(listener: Consumer<Double>): ISubscriptable.L {
		return addListener(DoubleConsumer { listener.accept(it) })
	}

	fun addListener(listener: DoubleConsumer): ISubscriptable.L

	class Impl : IDoubleSubcripable, Consumer<Double>, DoubleConsumer {
		private inner class L(val callback: DoubleConsumer) : ISubscriptable.L {
			private var isRemoved = false

			init {
				subscribers.add(this)
			}

			override fun remove() {
				if (!isRemoved) {
					isRemoved = true
					queue.add(this)
				}
			}
		}

		private val subscribers = ArrayList<L>(0)
		private val queue = ArrayList<L>(0)

		override fun addListener(listener: DoubleConsumer): ISubscriptable.L {
			return L(listener)
		}

		override fun accept(t: Double) {
			queue.forEach { subscribers.remove(it) }
			queue.clear()
			subscribers.forEach { it.callback.accept(t) }
		}
	}
}