package ru.dbotthepony.kommons.event

import java.util.function.Consumer
import java.util.function.LongConsumer

interface ILongSubcripable : ISubscriptable<Long> {
	@Deprecated("Use type specific listener")
	override fun addListener(listener: Consumer<Long>): ISubscriptable.L {
		return addListener(LongConsumer { listener.accept(it) })
	}

	fun addListener(listener: LongConsumer): ISubscriptable.L

	class Impl : ILongSubcripable, Consumer<Long>, LongConsumer {
		private inner class L(val callback: LongConsumer) : ISubscriptable.L {
			private var isRemoved = false

			init {
				subscribers.add(this)
			}

			override fun remove() {
				if (!isRemoved) {
					isRemoved = true
					queue.add(this)
				}
			}
		}

		private val subscribers = ArrayList<L>(0)
		private val queue = ArrayList<L>(0)

		override fun addListener(listener: LongConsumer): ISubscriptable.L {
			return L(listener)
		}

		override fun accept(t: Long) {
			queue.forEach { subscribers.remove(it) }
			queue.clear()
			subscribers.forEach { it.callback.accept(t) }
		}
	}
}